
#include "usgard.h"
#include "menuvars.h"
#include "formvars.h"
#include "boxvars.h"

scf_op	=	$37
jp_op	=	$C3
call_op	=	$CD
ret_op	=	$C9

jr_c_op	=	$38
jr_nc_op	=	$30
and_indhl_op	=	$A6
xor_indhl_op	=	$AE

#define	LD_BC_HL	ld b,h\ ld c,l
#define	EX_HL		ld a,h\ ld h,l\ ld l,a
#define	EX_BC		ld a,b\ ld b,c\ ld c,a
#define	ADD_C(x)	ld a,x\ add a,c\ ld c,a
#define	ADD_D(x)	ld a,x\ add a,d\ ld d,a
#define	A_X_6B	add a,a\ ld b,a\ add a,a\ add a,b
#define	A_X_6C	add a,a\ ld c,a\ add a,a\ add a,c
#define	A_X_6D	add a,a\ ld d,a\ add a,a\ add a,d

IXY	=	MENU_Y - MENU_FLAG
IXX	=	MENU_X - MENU_FLAG
IXWidth	=	MENU_WIDTH - MENU_FLAG
IXHeight	=	MENU_HEIGHT - MENU_FLAG
IXRelCur	=	MENU_RELCUR - MENU_FLAG
IXDown	=	7
IXUp	=	6
IXTitle	=	0
IXBuff	=	1
IXBorder	=	2
IXInsNums	=	3

DIV_HL_A	=	UNPACK_HL+2

.org 0

 ld (MENU_LIBADDR),hl
 ld hl,MENU_LIBLINK
 ld (hl),jp_op
 inc hl
 ld de,&FuncBrancher
 ld (hl),e
 inc hl
 ld (hl),d

 ld hl,&BoxString
 push hl
 call VAR_GET
 pop hl
 ret c
 call RELOC
 call &CallHL

 ld hl,&FormString
 push hl
 call VAR_GET
 pop hl
 ld a,DispStringNoForm - CAD_DispStringJump - 2
 jr c,Error_NoBox
 call RELOC
 call &CallHL
 xor a
Error_NoBox:
 ld (&CAD_DispStringJump+1),a
 or a
 ret


RemoveLib:
 ld hl,&FormString
 call DERELOC
 ld hl,&BoxString
 jp DERELOC


CallHL:
 jp (hl)


FuncBrancher:
 push de
 di
 inc sp\ inc sp
 ex (sp),hl
 ld e,(hl)
 inc hl
 ex (sp),hl
 dec sp\ dec sp
 ei
 push af
 push hl
 ld d,0
 ld hl,&LibFuncs
 ex de,hl
 add hl,hl
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ld hl,(MENU_LIBADDR)
 add hl,de
 ld ($8C8F+1),hl
 pop hl
 pop af
 pop de
 ld ix,MENU_FLAG
 jp $8C8F


LibFuncs:
.dw InitMenu
.dw ResetMenu
.dw XORCur
.dw GetMenuString
.dw GetString
.dw FindAndDisp
.dw ClearAndDisp
.dw CurDown
.dw CurUp

.dw CheckBounds
.dw CheckCur

.dw WaitMenu
.dw RemoveLib

#include "menu.h"

#include "bounds.h"

WaitMenu:
 call &ResetMenu
WM_Reset:
 call &XORCur
WM_KeyLoop:
 halt
 call GET_KEY
 or a
 jr z,WM_KeyLoop
 cp $01			;$01 = UP
 jr nz,WM_NoDown
 call &CurDown
 jr WM_Reset
WM_NoDown:
 cp $04			;$04 = DOWN
 jr nz,WM_NoUp
 call &CurUp
 jr WM_Reset
WM_NoUp:
 ld hl,MENU_ABSCUR

 cp $0A			;$0A = PLUS
 jr nz,WM_NoPageDown
 ld a,(hl)
 dec hl\ dec hl
 add a,(hl)
 dec a\ dec a
 inc hl
 dec a
 cp (hl)
 jr c,$+3
 xor a
 inc a
 inc hl
 ld (hl),a
 jr WaitMenu
WM_NoPageDown:
 cp $0B			;$0B = MINUS
 jr nz,WM_NoPageUp
 ld a,(hl)
 dec hl\ dec hl
 sub (hl)
 inc a\ inc a
 ld (MENU_ABSCUR),a
 jr WaitMenu
WM_NoPageUp:
 cp $09			;K_ENTER = $09
 ret z
 cp $37			;K_EXIT = $37
 scf
 ret z
 ccf
 bit IXInsNums,(ix+$00)
 jr nz,WM_CheckNumKeys
 or a
 ret
WM_CheckNumKeys:
 ld hl,&NumKeys+9
 ld bc,10
 cpdr
 ret nz
 ld b,a
 ld a,(MENU_HEIGHT)
 inc c
 cp c
 jr c,WM_KeyLoop
 ld a,c
 ld (MENU_ABSCUR),a
 xor a
 ld a,b
 ret

NumKeys:
;ScanCodes of #s 0-9 in order
.db $21,$22,$1A,$12,$23,$1B,$13,$24,$1C,$14



FormString:
.db "formlib",0
BoxString:
.db "boxlib",0

.end
