
#include "../usgard.h"
#include "../p85xvars.h"
#include "../menuvars.h"
#include "../inpvars.h"

StrArray	=	TEXT_MEM2
LastMatch	=	StrArray+2
NumMatches	=	LastMatch+1

BestMatch	=	LastMatch
BestRating	=	BestMatch+1

EnterString	=	BestRating+2


.org 0
.db "PXM"
SearchStr:
.db "Search ",0

 ld a,(DataNum)
 or a
 ret z
 ld hl,&MenuBytes
 ld de,MENU_FLAG
 ld bc,8
 ldir
 ld (MENU_LENGTH),a	;defines menu parameters needed in MENULIB

LoadTitle:
 ld hl,&SearchStr
 ld de,GRAPH_MEM
 call COPY_STRING
 call &GetModeString
 call COPY_STRING\ inc de	;"Search " + "(Exact):"/"(Closest):" = title

;copy all the data strings' titles to use as menu entries
 ld a,(DataNum)
 ld b,a
 ld hl,DataAddrTab
CopyDataStrings:
 push hl
 call LD_HL_MHL
 inc hl
 call COPY_STRING\ inc de
 pop hl
 inc hl
 inc hl
 djnz CopyDataStrings

 MENU_CALL(MENU_INIT)	;initialize menu (check parameters, put title, draw
WaitMenu:			; border, etc.)
 MENU_CALL(MENU_WAIT)	;turn menu cursor on, wait for "unidentified" key
 ret c			;if CF = C, EXIT pressed
 jr z,DataStringSelected	;if ZF = Z, ENTER or valid number pressed
 cp $17			;$17 = CUSTOM
 jr nz,WaitMenu
 ld hl,&SearchMode	;if CUSTOM pressed, switch between search modes
 ld a,(hl)
 xor 1
 ld (hl),a
 jr LoadTitle
DataStringSelected:

 ld a,(MENU_ABSCUR)
 add a,a
 ld e,a
 ld d,0
 ld hl,DataAddrTab-2
 add hl,de
 call LD_HL_MHL
;HL -> selected data string (type byte followed by description string)

 ld a,(ConvNum)
 or a
 ret z
 ld b,a
 ld a,(hl)\ inc hl	;A = data type byte
 ld de,$0101
 ld ($800C),de
 call D_ZT_STR		;display description string
 ld de,$0102
 ld ($800C),de

;load address of corresponding converter into $8C8F+1
 push hl
 ld hl,(ConvAddrTab)
LoadConverter:
 ld e,(hl)\ inc hl
 ld d,(hl)\ inc hl
 ex de,hl
 cp (hl)
 jr z,ConverterFound
 ex de,hl
 djnz LoadConverter
 pop hl
 ret
ConverterFound:
 inc hl
 ld ($8C8F+1),hl
 pop hl

;get the length of all converted strings
 xor a
 ld de,$0000
CheckLength:
 inc a
 push af
 push hl
 push de
 ld de,EnterString
 push de
 call $8C8F
 inc de
 ex de,hl			;HL -> end of converted string
 pop de			;DE -> beginning
 or a\ sbc hl,de		;HL = length of converted string
 pop de			;DE = running sum of lengths
 add hl,de			;add length to running sum
 ex de,hl			;save into DE
 pop hl			;HL -> data string
 pop af
 cp 112
 jr c,CheckLength
;DE = required amount of temp/free mem to put all 112 converted strings

 push hl
 ld hl,1024
 sbc hl,de
 ld hl,GRAPH_MEM
 jr nc,LoadData		;if everything fits into GRAPH_MEM, use GRAPH_MEM
 ld hl,($8BE5)		;HL -> end of VAT
 dec hl
 dec hl
 ld  bc,($8BE1)
 or a\ sbc hl,bc		;HL = number of bytes of free memory
 sbc hl,de
 ld h,b\ ld l,c		;HL -> first free byte of mem
 jr nc,LoadData		;if everything fits into free RAM, use the free RAM
 pop hl
 ld hl,&FreeMemStr
 call D_ZT_STR		;display "not enough free mem!"
 ld bc,$0103
 ld ($800C),bc
 push hl
 ex de,hl
 call D_HL_DECI		;display number of bytes required
 pop hl
 call D_ZT_STR		;display " bytes"
 ld hl,&RequiredStr
 call D_ZT_STR		;display " required!"
 jp OTH_PAUSE
LoadData:
 ld (StrArray),hl		;(StrArray) = address of converted strings
 ex de,hl
 pop hl

;convert all 112 strings to DE = (StrArray)
 xor a
BuildData:
 inc a
 push af
 push hl
 call $8C8F
 pop hl
 xor a
 ld (de),a\ inc de
 pop af
 cp 112
 jr c,BuildData

 ld hl,&SearchStr		;display "Search "
 call D_ZT_STR
 call &GetModeString
 call D_ZT_STR		;display "(Exact):"/"(Closest):"
 ld hl,$0103
 ld ($800C),hl

;find and relocate INPUTLIB
 ld hl,&InputLibStr
 push hl
 call VAR_GET
 pop hl
 jr nc,NoInputLibError
 call D_ZT_STR		;if INPUTLIB not found, display "inputlib"
 call D_ZT_STR		;display " required!"
 jp OTH_PAUSE
NoInputLibError:
 call RELOC
 call &CallHL

 ld hl,EnterString
 ld (INP_STRADDR),hl
 xor a
 ld (hl),a
 inc a
 ld (INP_STARTCOL),a	;define some parameters used by INPUTLIB

 set 2,(iy+$0C)		;cursor flash enabled
 res 5,(iy+$0D)		;graph cursor disabled
 res 6,(iy+$0D)		;MODE-type cursor disabled

 ld a,(&SearchMode)
 or a
 jr z,SearchExact


SearchClosest:
 ld a,19
 ld (INP_MAXLENGTH),a
 INP_CALL(INP_INPUTSTRING)	;get user-defined string to EnterString
 jr c,RemoveInputLib	;if CF = C, EXIT pressed (remove INPUTLIB)

SClosestMerge:
 ld hl,$FFFF
 ld (BestRating),hl	;(BestRating) = worst possible rating
 ld hl,(StrArray)		;HL -> array of converted strings
 ld bc,112<<8 + 1		;B = counter	;C = current string position
FindBestRating:
 ld de,EnterString	;DE -> entered string
 ld ix,$0000		;IX = rated difference between strings HL and DE
 push bc
 ld b,8			;initialize multiplier to 8
FBR_Loop:
 ld a,(de)
 sub (hl)
 jr nc,$+4
 neg				;A = difference between corresponding chars
 push bc
 push hl
 ld l,a
 ld h,0
 dec b
 jr z,FBR_NoAdd
FBR_Add:
 add hl,hl
 djnz FBR_Add
FBR_NoAdd:
 ld b,h\ ld c,l		;BC = HL = rated difference between chars
 add ix,bc			;add to running rated difference
 pop hl
 pop bc
 jr c,FBR_OverFlow	;if CF = C, IX overflowed
 ld a,(hl)
 or a
 jr z,FBR_Rated		;jump if to end of converted string
 inc hl
 ld a,(de)\ inc de
 or a
 jr z,FBR_Rated		;jump if to end of inputted string
 dec b
 jr nz,FBR_Loop
 inc b
 jr FBR_Loop		;reloop with B = B - 1 unless B = 1

FBR_OverFlow:
 ld ix,$FFFF
FBR_Rated:
 ld b,a\ ld c,a
 cpir				;HL -> next string
 pop bc

 ld de,(BestRating)
 push ix
 ex (sp),hl
 sbc hl,de
 jr nc,FBR_NotBetter	;if IX >= (BestRating), jump
 add hl,de
 ld a,c
 ld (BestMatch),a		;define new best match
 ld (BestRating),hl	;define new best rating
FBR_NotBetter:
 pop hl
 inc c
 djnz FindBestRating	;loop through all 112 strings
 jr SearchMerge		;define new atomic number


SearchExact:

WaitKey:
 ld a,($800D)
 cp 20
 jr nc,RemoveInputLib	;if cursor at last column, just quit

 INP_CALL(INP_GETKEY3)	;get keycode3 key press in BC

 sub $06			;$06 = keycode2 for ENTER
 jr z,SClosestMerge
 dec a			;$07 = keycode2 for EXIT
 jr nz,CheckSecond
RemoveInputLib:
 res 2,(iy+$0C)
 call INT_REMOVE
 ld hl,&InputLibStr
 jp DERELOC

CheckSecond:
 inc b
 jr nz,WaitKey		;if B = $FF, check if C valid to display the char
CheckFirst:
 inc c
 dec c
 jr z,WaitKey		;if C = 0, invalid key press

 ld hl,(INP_STRADDR)
 ld (hl),c			;load char into string
 inc hl
 ld (hl),0			;ZT
 ld (INP_STRADDR),hl
 ld a,c
 call TR_CHARPUT		;print char to screen

 ld hl,$800D
 inc (hl)			;increase cursor position
 ld a,(hl)
 ld (INP_STARTCOL),a

 ld hl,(StrArray)
 xor a
 ld (NumMatches),a	;no matches to inputted string found yet
 ld bc,112<<8 + 1
FindMatches:
 push hl
 ld de,EnterString
FM_Compare:			;compare strings to check if equal
 ld a,(de)\ inc de
 or a
 jr z,FM_Match
 cp (hl)\ inc hl
 jr z,FM_Compare
 jr FM_NoMatch
FM_Match:			;if strings match, save that
 ld hl,LastMatch
 ld (hl),c
 inc hl
 inc (hl)
FM_NoMatch:			;if strings don't match, move to next string
 pop hl
 push bc
 xor a
 ld c,a\ ld b,a
 cpir
 pop bc
 inc c
 djnz FindMatches

 ld a,(NumMatches)
 or a
 jr z,RemoveInputLib	;if no matches found, quit
 dec a
 jr nz,WaitKey		;if > 1 matches found, narrow search
SearchMerge:
 ld a,(LastMatch)		;else, unique match found, save to memory
 ld (CurElNum),a
 jr RemoveInputLib




GetModeString:
 ld hl,&SearchMode
 ld a,(hl)
 inc hl
 or a
 ret z
 ld hl,&Closest
 ret


MenuBytes:
;.db <MENU_FLAG>,<MENU_Y>,<MENU_X>,<MENU_WIDTH>,<MENU_HEIGHT>,
; <MENU_LENGTH>,<MENU_ABSCUR>,<MENU_RELCUR>
.db $0F,2,2,124,9,$00,1,1


CallHL:
 jp (hl)


SearchMode:
.db 0
Exact:
.db "(Exact):",0
Closest:
.db "(Closest):",0

FreeMemStr:
.db "not enough free mem!",0
.db " bytes",0

InputLibStr:
.db "inputlib",0
RequiredStr:
.db " required!",0

.end
